import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import java.util.*;

/**
* The name should be self-explanatory. Creates an About box, that utilizes an JEditorPane to
* display HTML formatted text about the program. The close operation that gets performed when
* clicking on the Close button, is an anonymous inner class that disposes of the entire AboutBox object.
*/
public class AboutBox extends JFrame {
	public AboutBox() {
		super(GBLText.t_title + " : " + GBLText.t_about);
		getContentPane().setBackground(Color.white);
		setSize(350,300);
		JEditorPane pane = new JEditorPane();
		JButton close = new JButton ("Close");
		pane.setContentType("text/html");
		pane.setEditable(false);
		pane.setText(" <html> <body> <center> <b>GridBagLayout Editor</b> </center> <br> Dette er et program som skal la deg leke med GridBagLayout.  Et prosjekt som sikkert hadde blitt mye morsommere, om det ikke var for at man har alt for mye annet &aring; finne p&aring;.  <p align=right> &copy; JL & MJA 2004 </p> </body> </html>");
		getContentPane().setLayout(new BorderLayout());
		getContentPane().add(new JLabel(new ImageIcon(getClass().getResource("icons/hig_logo.gif"))), BorderLayout.NORTH);
		getContentPane().add(pane, BorderLayout.CENTER);
		getContentPane().add(close, BorderLayout.SOUTH);
		close.addActionListener(new ActionListener () {
			public void actionPerformed (ActionEvent ae) {
				dispose(); // Deletes the AboutBox object.
			}
		});
		setVisible(true);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE); // Deletes the AboutBox object when window is closed through WM.
	}
}
