import java.awt.*;
import javax.swing.*;
import javax.swing.table.*;
import javax.swing.border.*;

public class CellTypeRenderer extends JLabel implements TableCellRenderer {

  public CellTypeRenderer () {
    setOpaque(true); //MUST do this for background to show up.
    setHorizontalAlignment(CENTER);
    setVerticalAlignment(CENTER);
  }

  public Component getTableCellRendererComponent(
                          JTable table, Object value,
                          boolean isSelected, boolean hasFocus,
                          int row, int column) {
    if (isSelected) {
      setBackground (table.getSelectionBackground ());
    } else {
      setBackground (table.getBackground ());
    }
    setText ("");
    setIcon (new ImageIcon (getClass().getResource("icons/renderers/"+ ((String)value) +".png")));
    return this;
  }
}