import javax.swing.table.AbstractTableModel;

/**
* Extension of AbstractTableModel....
*/
class GBLModel extends AbstractTableModel {
  private String columnNames[] = { "Type", "Variable Name", "Text", "Row", "Column", "Rows", "Columns", "Fill", "Anchor" };
  public java.util.Vector data = new java.util.Vector();

  /**
  * Adds a row of GLBRow type to the TableModel
  */
  public void addRow (GBLRow row) {
    data.add (row);
    fireTableRowsInserted (data.size()-1, data.size()-1);
  }

  /**
  * Returns the number of columns in this TableModel
  */
  public int getColumnCount() {
    return columnNames.length;
  }

  /**
  * Gives the number of rows currently in the Table.
  */
  public int getRowCount() {
    return data.size();
  }

  /**
  * Returns an Object containing the value at the cell specified by "row"/"col".
  */
  public Object getValueAt(int row, int col) {
    switch (col) {
//      case 0 : return new Integer (((GBLRow)data.elementAt(row)).getType());
      case 0 : return new String (((GBLRow)data.elementAt(row)).getType());
      case 1 : return ((GBLRow)data.elementAt(row)).getName(); 
      case 2 : return ((GBLRow)data.elementAt(row)).getText();
      case 3 : return new Integer (((GBLRow)data.elementAt(row)).getRow());
      case 4 : return new Integer (((GBLRow)data.elementAt(row)).getColumn());
      case 5 : return new Integer (((GBLRow)data.elementAt(row)).getRows());
      case 6 : return new Integer (((GBLRow)data.elementAt(row)).getColumns());
//      case 7 : return new Integer (((GBLRow)data.elementAt(row)).getFill());
//      case 8 : return new Integer (((GBLRow)data.elementAt(row)).getAnchor());
      case 7 : return new String (((GBLRow)data.elementAt(row)).getFill());
      case 8 : return new String (((GBLRow)data.elementAt(row)).getAnchor());
    }
    return null;
  }
  

  /**
  * Returns the name of column col
  */
  public String getColumnName(int col) {
    return columnNames[col];
  }

  public Object[] getRowArray() {
    return data.toArray();
  }

  /**
  * Returns the class type used to store data in column "col"
  */
  public Class getColumnClass(int c) {
    return getValueAt(0, c).getClass();
  }

   // Don't need to implement this method unless your table's
   // editable.
  /**
  * Returns true if a cell is editable, false if not. As all cells in GBLEditor's table
  * are editable, this method always returns true
  * @return boolean true
  */
  public boolean isCellEditable(int row, int col) {
    //Note that the data/cell address is constant,
    //no matter where the cell appears onscreen.
      return true;
  }

  
   // Don't need to implement this method unless your table's
   // data can change.
  /**
  * This is called everytime a cell in the table is edited/updated/changed. Takes a generic Object
  * reference as the parameter "value", and casts this Object to the internally needed data type.
  */
  public void setValueAt(Object value, int row, int col) {
    GBLRow gblr = (GBLRow)data.elementAt(row);
    switch (col) {
//      case 0 : gblr.setType (((Integer))value.intValue());
//               break;
      case 0 : gblr.setType ((String)value);
               break;
      case 1 : gblr.setName ((String)value);
               break;
      case 2 : gblr.setText ((String)value);
               break;
      case 3 : gblr.setRow (((Integer)value).intValue());
               break;
      case 4 : gblr.setColumn (((Integer)value).intValue());
               break;
      case 5 : gblr.setRows (((Integer)value).intValue());
               break;
      case 6 : gblr.setColumns (((Integer)value).intValue());
               break;
//      case 7 : gblr.setFill (((Integer)value).intValue());
//               break;
//      case 8 : gblr.setAnchor (((Integer)value).intValue());
//               break;
      case 7 : gblr.setFill ((String)value);
               break;
      case 8 : gblr.setAnchor ((String)value);
               break;
    }
    fireTableCellUpdated(row, col);
  }
}